#ifndef WCBE_FRAMEDUMPER_H__
#define WCBE_FRAMEDUMPER_H__

#include <gst/gst.h>
#include <gst/base/gstbasetransform.h>
#include <wcbe_lag_frame.h>

G_BEGIN_DECLS

/* #defines don't like whitespacey bits */
#define WCBE_TYPE_FRAMEDUMPER \
  (wcbe_framedumper_get_type())
#define WCBE_FRAMEDUMPER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_FRAMEDUMPER,WcbeFramedumper))
#define WCBE_FRAMEDUMPER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_FRAMEDUMPER,WcbeFramedumperClass))
#define WCBE_IS_FRAMEDUMPER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_FRAMEDUMPER))
#define WCBE_IS_FRAMEDUMPER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),WCBE_TYPE_FRAMEDUMPER))

typedef struct _WcbeFramedumper      WcbeFramedumper;
typedef struct _WcbeFramedumperClass WcbeFramedumperClass;

typedef enum {
    WCBE_FRAMEDUMP_ASCII,
    WCBE_FRAMEDUMP_BINARY
} WcbeFramedumpFormat;

#define WCBE_TYPE_FRAMEDUMP_FORMAT \
  (wcbe_framedump_format_get_type())

GType wcbe_framedump_format_get_type(void);

struct _WcbeFramedumper {
    GstBaseTransform element;
    gboolean do_output;
    WcbeFramedumpFormat format;
    gsize (*output_fn)(const lf_data_frame_word_t *df);
};

struct _WcbeFramedumperClass {
  GstBaseTransformClass parent_class;
};

GType wcbe_framedumper_get_type(void);

G_END_DECLS

#endif /* WCBE_FRAMEDUMPER_H__ */
