#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include <gst/gst.h>
#include <wcbe_src.h>
#include <wcbe_framedumper.h>
#include <wcbe_decoder.h>
#include <wcbe_sorter.h>
#include <wcbe_lagset_sink.h>

struct _elements_entry {
    const gchar *name;
    guint rank;
    GType (*type) (void);
};

static struct _elements_entry _elements[] = {
    {"wcbe_src", GST_RANK_NONE, wcbe_src_get_type},
    {"wcbe_framedumper", GST_RANK_NONE, wcbe_framedumper_get_type},
    {"wcbe_decoder", GST_RANK_NONE, wcbe_decoder_get_type},
    {"wcbe_sorter", GST_RANK_NONE, wcbe_sorter_get_type},
    {"wcbe_lagset_sink", GST_RANK_NONE, wcbe_lagset_sink_get_type},
    {NULL, 0},
};

static gboolean
plugin_init (GstPlugin *plugin)
{
    struct _elements_entry *element = _elements;

    while (element->name != NULL) {
        if (!gst_element_register(plugin, element->name, element->rank,
                                  element->type())) {
            return FALSE;
        }
        element++;
    }
    return TRUE;
}

GST_PLUGIN_DEFINE (
    GST_VERSION_MAJOR,
    GST_VERSION_MINOR,
    "wcbeinputstage",
    "WIDAR backend input stage elements",
    plugin_init,
    VERSION,
    "GPL",
    PACKAGE,
    "http://www.aoc.nrao.edu/evla"
    );
