#ifndef WCBE_LAGSET_SINK_H__
#define WCBE_LAGSET_SINK_H__

#include <gst/gst.h>
#include <gst/base/gstbasesink.h>

G_BEGIN_DECLS

/* #defines don't like whitespacey bits */
#define WCBE_TYPE_LAGSET_SINK \
  (wcbe_lagset_sink_get_type())
#define WCBE_LAGSET_SINK(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_LAGSET_SINK,WcbeLagsetSink))
#define WCBE_LAGSET_SINK_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_LAGSET_SINK,WcbeLagsetSinkClass))
#define WCBE_IS_LAGSET_SINK(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_LAGSET_SINK))
#define WCBE_IS_LAGSET_SINK_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),WCBE_TYPE_LAGSET_SINK))

typedef struct _WcbeLagsetSink      WcbeLagsetSink;
typedef struct _WcbeLagsetSinkClass WcbeLagsetSinkClass;

typedef struct wcbe_lagset_sink_cfg {
    gchar *name;
    gchar *sockdir;
    GArray *socks;
    GHashTable *destinations;
    gboolean destroy;
    WcbeLagsetSink *sink;
} wcbe_lagset_sink_cfg_t;

struct _WcbeLagsetSink {
    GstBaseSink basesink;
    gchar *sockdir;
    gint sockfd;
    gint control_sock[2];
    GHashTable *configurations;
    wcbe_lagset_sink_cfg_t *config;
};

struct _WcbeLagsetSinkClass {
    GstBaseSinkClass parent_class;
};

GType wcbe_lagset_sink_get_type(void);

extern gboolean wcbe_lagset_sink_create_config(WcbeLagsetSink *sink,
                                               const gchar *config,
                                               const gchar *name);
extern gboolean wcbe_lagset_sink_activate_config(WcbeLagsetSink *sink,
                                                 const gchar *cfg_name);
extern void wcbe_lagset_sink_destroy_config(WcbeLagsetSink *sink,
                                            const gchar *cfg_name);

G_END_DECLS

#endif /* WCBE_LAGSET_SINK_H__ */
