#ifndef WCBE_LAGSET_SRC_H__
#define WCBE_LAGSET_SRC_H__

#include <gst/gst.h>
#include <gst/base/gstpushsrc.h>

G_BEGIN_DECLS

/* #defines don't like whitespacey bits */
#define WCBE_TYPE_LAGSET_SRC \
  (wcbe_lagset_src_get_type())
#define WCBE_LAGSET_SRC(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_LAGSET_SRC,WcbeLagsetSrc))
#define WCBE_LAGSET_SRC_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_LAGSET_SRC,WcbeLagsetSrcClass))
#define WCBE_IS_LAGSET_SRC(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_LAGSET_SRC))
#define WCBE_IS_LAGSET_SRC_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),WCBE_TYPE_LAGSET_SRC))

typedef struct _WcbeLagsetSrc      WcbeLagsetSrc;
typedef struct _WcbeLagsetSrcClass WcbeLagsetSrcClass;

struct _WcbeLagsetSrc {
    GstPushSrc element;
    gchar *sockname;
    gint sockfd;
    gint control_sock[2];
    gint epollfd;
    guint64 num_lagsets;
    GstCaps *caps;
};

struct _WcbeLagsetSrcClass {
    GstPushSrcClass parent_class;
};

GType wcbe_lagset_src_get_type(void);

G_END_DECLS

#endif /* WCBE_LAGSET_SRC_H__ */
