#ifndef WCBE_SORTER_H__
#define WCBE_SORTER_H__

#include <gst/gst.h>

G_BEGIN_DECLS

/* #defines don't like whitespacey bits */
#define WCBE_TYPE_SORTER \
  (wcbe_sorter_get_type())
#define WCBE_SORTER(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),WCBE_TYPE_SORTER,WcbeSorter))
#define WCBE_SORTER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),WCBE_TYPE_SORTER,WcbeSorterClass))
#define WCBE_IS_SORTER(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),WCBE_TYPE_SORTER))
#define WCBE_IS_SORTER_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),WCBBE_TYPE_SORTER))

typedef struct _WcbeSorter      WcbeSorter;
typedef struct _WcbeSorterClass WcbeSorterClass;

typedef struct wcbe_sorter_cfg {
    gchar *name;
    GSList *queues;
    GHashTable *destinations;
    gboolean destroy;
    WcbeSorter *sorter;
} wcbe_sorter_cfg_t;

struct _WcbeSorter {
    GstElement element;

    GstPad *sinkpad, *srcpad;
    GThread *timeout_thread;
    GMutex *config_mutex;
    GCond *config_cond;
    gboolean new_config;
    wcbe_sorter_cfg_t *config;
    GHashTable *configurations;
    GstBuffer *dummy_buffer;
};

struct _WcbeSorterClass {
    GstElementClass parent_class;
};

GType wcbe_sorter_get_type(void);

extern gboolean wcbe_sorter_create_config(WcbeSorter *sorter,
                                          const gchar *config,
                                          const gchar *name);
extern gboolean wcbe_sorter_activate_config(WcbeSorter *sorter,
                                            const gchar *cfg_name);
extern void wcbe_sorter_destroy_config(WcbeSorter *sorter,
                                       const gchar *cfg_name);

G_END_DECLS

#endif /* WCBE_SORTER_H__ */
